-- Adminer 4.6.1 MySQL dump

SET NAMES utf8;
SET time_zone = '+00:00';
SET foreign_key_checks = 0;
SET sql_mode = 'NO_AUTO_VALUE_ON_ZERO';

DROP TABLE IF EXISTS `control`;
CREATE TABLE `control` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `aktiv` int(1) unsigned NOT NULL,
  `date` date DEFAULT NULL,
  `WoTag` smallint(1) unsigned NOT NULL,
  `ontime` time DEFAULT NULL,
  `S_aufuntergang` int(1) NOT NULL DEFAULT '0' COMMENT 'Sonnenaufgang',
  `offset` int(11) NOT NULL DEFAULT '0' COMMENT 'Verschiebung zum Sonnnenauf- u. -untergang in Minuten',
  `device_id` int(11) NOT NULL,
  `execute` datetime DEFAULT '0000-00-00 00:00:00',
  `realTime` time NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

TRUNCATE `control`;
INSERT INTO `control` (`id`, `aktiv`, `date`, `WoTag`, `ontime`, `S_aufuntergang`, `offset`, `device_id`, `execute`, `realTime`) VALUES
(1,	1,	NULL,	127,	'05:35:00',	0,	0,	16,	NULL,	'05:35:00'),
(2,	1,	NULL,	127,	'06:40:00',	0,	0,	16,	NULL,	'06:40:00'),
(3,	1,	NULL,	127,	'07:44:00',	0,	0,	14,	NULL,	'07:44:00'),
(4,	1,	NULL,	127,	'09:03:00',	0,	0,	16,	NULL,	'09:03:00'),
(5,	1,	NULL,	127,	'05:49:00',	0,	0,	13,	NULL,	'05:49:00'),
(6,	1,	NULL,	127,	'06:39:00',	0,	0,	15,	NULL,	'06:39:00'),
(7,	1,	NULL,	127,	'04:00:00',	0,	0,	13,	NULL,	'04:00:00'),
(8,	1,	NULL,	127,	'05:00:00',	0,	0,	14,	NULL,	'05:00:00'),
(9,	1,	NULL,	127,	'05:10:00',	0,	0,	15,	NULL,	'05:10:00'),
(10,	1,	NULL,	127,	'06:30:00',	0,	0,	14,	NULL,	'06:30:00'),
(11,	1,	NULL,	127,	'07:00:00',	0,	0,	13,	NULL,	'07:00:00'),
(12,	1,	NULL,	127,	'08:45:00',	0,	0,	15,	NULL,	'08:45:00'),
(13,	0,	NULL,	127,	'07:00:00',	0,	0,	9,	NULL,	'07:00:00'),
(14,	0,	NULL,	127,	'08:45:00',	0,	0,	10,	NULL,	'08:45:00'),
(15,	1,	NULL,	48,	'08:45:00',	0,	0,	15,	NULL,	'08:45:00'),
(16,	1,	NULL,	0,	NULL,	0,	-15,	15,	NULL,	'00:00:00'),
(17,	1,	NULL,	0,	'22:00:00',	0,	0,	15,	NULL,	'00:00:00');

DROP TABLE IF EXISTS `device`;
CREATE TABLE `device` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `aktiv` int(1) unsigned NOT NULL,
  `device_aktion` varchar(40) NOT NULL,
  `IP_DNS` varchar(50) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

TRUNCATE `device`;
INSERT INTO `device` (`id`, `aktiv`, `device_aktion`, `IP_DNS`) VALUES
(1,	0,	'ESP_an',	'192.168.2.112'),
(2,	0,	'ESP_aus',	'192.168.2.112'),
(3,	1,	'Wz_an',	'192.168.2.84'),
(4,	1,	'Wz_aus',	'192.168.2.84'),
(5,	1,	'KLicht_an',	'192.168.2.80'),
(6,	1,	'KLicht_aus',	'192.168.2.80'),
(7,	0,	'KRadio_an',	'192.168.2.82'),
(8,	0,	'KRadio_aus',	'192.168.2.82'),
(9,	1,	'S20A_an',	'192.168.2.81'),
(10,	1,	'S20A_aus',	'192.168.2.81'),
(11,	1,	'Umwälz_an',	'192.168.2.81'),
(12,	1,	'Umwälz_aus',	'192.168.2.81'),
(13,	1,	'Sonoff C_an',	'192.168.2.83'),
(14,	1,	'Sonoff C_aus',	'192.168.2.83'),
(15,	1,	'Obi2_an',	'192.168.2.85'),
(16,	1,	'Obi2_aus',	'192.168.2.85');

DROP TABLE IF EXISTS `log`;
CREATE TABLE `log` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `am` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `control_id` bigint(20) NOT NULL,
  `device_aktion` varchar(40) NOT NULL,
  `send` varchar(100) NOT NULL,
  `RC` varchar(50) DEFAULT NULL,
  `RC_device` varchar(50) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

TRUNCATE `log`;

-- 2018-05-05 17:32:10
