<?php
// Scriptprojekt: IoTControl V1.2
// File: 'Functions.php'

function dbexecuteupdate($Hnd, $id, $dtime) {
	// in DB den Ausfhrungszeitpunkt setzen
	$stm=$Hnd->prepare('UPDATE control SET execute=:dtime WHERE id=:ID');
	$stm->bindParam(':ID', $id);
	$stm->bindParam(':dtime', $dtime);
	$stm->execute();
}

function ZyklenIntervall($daten,$DateNow){
	//Prfe Eintrag ob Zyklus fr Tag und Datum gltig
	$RC = FALSE;
	if(!$daten[date] == ''){ //Feld Ausfhrungsdatum enthalten, dann  
		if(strtotime($daten[date]) == $DateNow)
			$RC = TRUE;
	}elseif (!$daten[WoTag]) //WoTag = 0 ==> fr jeden Tag gltig
		$RC = TRUE;
		
	else{
			$WoTag = date("w",$DateNow);
			if(!$WoTag) //Welcher Tag? Fkt. gibt Sonntag als 0 zurck
				$WoTag = 7; //mache 0 -> 7 Sonntag
			if (pow(2,$WoTag-1) & $daten[WoTag]) //WoTag-Byte mit aktuellem Wochentag maskieren
				$RC = TRUE;
	}
	return $RC;
}

function ZyklenInitial($Hnd, $id, $n, $dtime ){
	//Zyklus initial setzen
	if($n){
		$dtime = '0000-00-00 00:00:00'; //Zyklus nicht zutreffend fr heute
		$stm=$Hnd->prepare('UPDATE control SET execute=:dtime WHERE id=:ID');
		$stm->bindParam(':dtime', $dtime);
	}else{
		$stm=$Hnd->prepare('UPDATE control SET execute=NULL WHERE id=:ID'); //Zyklus fr heute zutreffend
	}
	$stm->bindParam(':ID', $id);
	$stm->execute();
}

function insertDBLog($Hnd, $id, $Device_aktion, $send, $RC, $FriendlyName){
	//schreibe Table log
	$stm=$Hnd->prepare('INSERT INTO log (control_id, Device_aktion, send, RC, RC_device) VALUES (:ID,:DEVICE,:SND,:RC,:FRLNAME)');
	$stm->bindParam(':ID', $id);
	$stm->bindParam(':DEVICE', $Device_aktion);
	$stm->bindParam(':SND', $send);
	$stm->bindParam(':RC', $RC);
	$stm->bindParam(':FRLNAME', $FriendlyName);
	$stm->execute();
	echo '<br>InsertDBLog()<br>';
}

function IoTSwitch($Hnd, $IP_DNS, $Control_ID, $Device_aktion, $CNF_DateTime){
//Schalte das Gert mit Tasmota-Firmware
//Parameter:
// $Hnd           - PDO-Handle
// $IP_DNS        - Address des IoT-Gertes
// $Control_ID    - aktuelle ID der Table 'control'
// $Device_aktion - Gertename Tbl 'device' z.B.: 'Licht_an' ==> '_an' ist die Aktion
// $CNF_DateTime  - Ausfhrungszeit

	$url1 = '/cm?user='.CNF_USER.'&password='.CNF_PWD.'&cmnd=';  //
	$SubAction1 = 'http://'.$IP_DNS.$url1;
	
	$url2 = $url1 . 'Status';		//zuerst Status abfragen, verbessert offensichtlich die Zuverlssigkeit beim folgenden Schalten!
	$rsp = HttpReq($IP_DNS, $url2);
	$JSON = explode('*', $rsp);
	$JSON1 = json_decode(stristr(str_replace(array('[',']'),'', $JSON[1]), '{'), true);
	$FriendlyName = $JSON1['Status']['FriendlyName'];
	echo ' $FriendlyName:',$FriendlyName;

	
	if(stristr($Device_aktion, '_an')){
		$SubAction2 = 'Power%20On'; //anschalten
		echo 'an------';
		$RC = '_an';
	}else{
		$SubAction2 = 'Power%20Off'; //ausschalten
		echo 'aus------';
		$RC = '_aus';
	}
	$cmd = $SubAction1 . $SubAction2;
	$url2 = $url1 . $SubAction2;
	$i = 0;
	do{ //Kommando ausfhren, 1x bis maximal n wiederholen
		if(i)
			sleep(1); //warte n-Sekunden beim wiederholten Durchlauf
		
		//ausfhren
		//$rsp = file_get_contents($cmd); //schlechtere Alternative!!!
		$rsp = HttpReq($IP_DNS, $url2);
		
		echo '<br>REQUEST';
		++$i;
		insertDBLog($Hnd, $Control_ID, $Device_aktion, $cmd, $rsp.'|'.$RC, $FriendlyName); //Aktionen in DB-Table 'log' schreiben
		echo '<br>InsetLOG_a';
	}while(!stristr($rsp, 'POWER') AND $i < 9); //Tasmota antwortet mit 'POWER' ?
	dbexecuteupdate($Hnd, $Control_ID, $CNF_DateTime); //Db-Update Execute setzen nach Ausfhren
	if(!stristr($rsp, 'POWER')){ //fehlerhaft auch nach n Wiederholungen
		insertDBLog($Hnd, $Control_ID, $Device_aktion, $cmd, 'ERROR: '.$rsp.'|'.$RC, $FriendlyName); //fehlerhafte Aktionen in DB-Table 'log' schreiben
		echo '<br>InsetLOG_b';
	}
	echo $i.' Device: '. $Device_aktion . ' nach ' . $rsp .'<br>';
}

function HttpReq($host, $url, $port=80, $timeout=6){
	$RC = $data ='';
	@$fp = fsockopen($host, $port, $errno, $errstr, $timeout);
	if($fp)
	{
		$request = 'GET '.$url.' HTTP/1.1'."\r\n";
		$request.= 'Host: '.$host."\r\n";
		$request.= 'Connection: keep-alive\r\n';
		$request.= 'Upgrade-Insecure-Requests: 1'."\r\n";
		$request.= 'Connection: Close'."\r\n\r\n";
		$request.= "\r\n";

		fwrite($fp, $request);
		stream_set_timeout($fp, 5);
		while (!feof($fp))
			$data .= fgets($fp, 256);
		fclose($fp);
		$RC = stristr($data, '{"POWER');
		if(!$RC)
			$RC = $data; //Rckgabe bei Statusabfrage
	}
	return $RC;
} 